.EXTERN     clipline;
.EXTERN     accrej;

/* Defines related to the Compare Accumulator (CACC) */
#define CACC6_MSK       0xfc000000                  /* top 6 bits of CACC   */
#define test_cacc(msk)  bit tst astat msk           /* CACC test instr      */

/* static registers */
#define REJECT          r15     /* = 0      */
#define ACCEPT          r14     /* = 1      */
#define CLIP            r13     /* = 2      */
#define SIX_ONES        r12     /* = 0x3f   */

/* First Endpoint Coordinates */
#define X1              f0
#define Y1              f1
#define Z1              f2

/* Second Endpoint Coordinates */
#define X2              f3
#define Y2              f4
#define Z2              f5

/* Outcodes for Each Endpoint */
#define OC1             r6
#define OC2             r7

/* indices to lists */
#define DSP_LIST        i1
#define CLIP_LIST       i2
