# 1 "demo2.c"
 









 
# 1 "C:\ADI\FXD_50\21xx\include\stdlib.h" 1













typedef unsigned int	size_t;
typedef	int		wchar_t;



typedef struct {int quot; int rem;} div_t;
typedef struct {long int quot; long int rem;} ldiv_t;

int	rand(void);
void	srand(unsigned int seed);
void	free(void *ptr);
void	*malloc(size_t size);
void	exit(int status);
int	abs(int j);
long int    labs(long int j);
double  fabs(double);


# 12 "demo2.c" 2





 
void initialize_data( int buffer[], int size );

 
extern int state[];                                  
extern void fir_init( void );                        
extern int fir_filt( int sample, int pm coeffs[] );  

 
int main( void )
{
   int i;
   int sample;                   

                                 
   static int pm coeffs[           22 ] = { 0x0015, 0x008F, 0x014B, 0x018D, 0x004A,
                                  0xFD5A, 0xFA64, 0xFA90, 0x008F, 0x0C2C,
                                  0x1965, 0x2239, 0x1965, 0x0C2C, 0x008F,
                                  0xFA90, 0xFA64, 0xFD5A, 0x004A, 0x018D,
                                  0x014B, 0x008F };

   static int data_buffer[      100 ];    

   fir_init();        
   srand( 0xb5ed );   
                     
    
   initialize_data( data_buffer,       100  );

    
   for( i=0; i <       100 ; i++)
   {
      sample = data_buffer[i];
      data_buffer[i] = fir_filt( sample, coeffs );
   }

    
   return( 1 );
}

void initialize_data( int buffer[], int size )
{
   int i;

   for( i=0; i < size; i++ )
      buffer[i] = ( 2*rand() ) - 32768;   
}
