   DEFINT N,M,L,K,I,J,E,O:CLS
   NSAMP=512:M=LOG(NSAMP)/LOG(2)
   N=NSAMP/2:M=M-1
   SCREEN 9,0
   DIM X(1000):DIM S(63):PI=3.14159265
   INPUT"please enter percent noise to be added to signal ",NS
   INPUT"please enter points/cycle desired ",CY
   'BUILD WAVEFORM
   FOR I = 0 TO NSAMP
     sn = (((rnd(1)*2)-1)*NS/100)
     X(I) = SIN(2*PI*I/CY)+sn
   NEXT
   CLS
   LINE(0,0)-(639,349),3,B
    ' SHOW ZERO VOLTAGE LINE
   LINE(50,75)-(512+50,75),3,,&H8888
    'PLOT NOISY WAVEFORM
   FOR I = 0 TO 512
     LINE(I+50,75-25*X(I))-((I+1)+50,75-25*X(I+1)),14
   NEXT

    ' SHOW -100 DB LINE
   LINE(45,300)-(512+50,300),3,,&H8888
    ' SHOW -80 DB LINE
   LINE(45,280)-(512+50,280),3,,&H8888
    ' SHOW -60 DB LINE
   LINE(45,260)-(512+50,260),3,,&H8888
    ' SHOW -40 DB LINE
   LINE(45,240)-(512+50,240),3,,&H8888
    ' SHOW -20 DB LINE
   LINE(45,220)-(512+50,220),3,,&H8888
    ' SHOW 0 DB LINE
   LINE(45,200)-(512+50,200),3,,&H8888
   LOCATE 22,2:PRINT"-100";
   LOCATE 19,2:PRINT"-60";
   LOCATE 15,2:PRINT" 0 dB";
   LOCATE 24,6:PRINT"0";
   LOCATE 24,71:PRINT".5 FS";
   LOCATE 12,33:PRINT"Power Spectrum";
   X=50:Y=303:CO=15:GOSUB ARROW

    ' PERFORM FFT FUNCTION
   GOSUB FFT

    ' GET MAGNITUDE OF EACH FREQUENCY
   FOR L=0 TO N-1:X(L)=(X(2*L)^2+X(2*L+1)^2):NEXT
    ' FIND LARGEST MAGNITUDE
   XMAX=0
   FOR L=0 TO N-1
     IF X(L) > XMAX THEN XMAX=X(L)
   NEXT
    ' CONVERT TO DBs
   FOR L=0 TO N-1
     X(L)=10*LOG10(X(L)/XMAX)
   NEXT
    ' FIND SMALLEST VALUE
   XMIN=0
   FOR L=0 TO N-1
     IF X(L) < XMIN THEN XMIN=X(L)
   NEXT
   XSCALE=512/N
    ' PLOT SPECTRUM
   FOR L=0 TO N-1
     XP=L*XSCALE
     LINE(XP+50,300)-(XP+50,300-100*(1-(X(L)/-100))),14
   NEXT
100 A$=INKEY$:IF A$="" THEN 100
if len(a$)=2 then
  IF ASC(MID$(A$,2,1))=77 AND (X<=562) THEN
    CO=0
    GOSUB ARROW
    X=X+2
    CO=15
    GOSUB ARROW
  END IF
  IF ASC(MID$(A$,2,1))=75 AND (X>50) THEN
    CO=0
    GOSUB ARROW
    X=X-2
    CO=15
    GOSUB ARROW
  END IF
end if
IF A$="Q" OR A$="q" then stop
GOTO 100
stop

' DRAW ARROW
ARROW:
    LOCATE 24,30:PRINT"                              ";
    LOCATE 24,35
    PRINT"F = ";:PRINT ((X-50)/2)*(.5/256);:PRINT" Fs";
    LINE(X,Y)-(X,Y+10),CO
    PSET(X+1,Y+1),CO
    PSET(X-1,Y+1),CO
    PSET(X+1,Y+2),CO
    PSET(X-1,Y+2),CO
    PSET(X+2,Y+3),CO
    PSET(X-2,Y+3),CO
    LINE(X,Y-116)-(X,Y-106),CO
    PSET(X+1,Y-106-1),CO
    PSET(X-1,Y-106-1),CO
    PSET(X+1,Y-106-2),CO
    PSET(X-1,Y-106-2),CO
    PSET(X+2,Y-106-3),CO
    PSET(X-2,Y-106-3),CO
RETURN

FFT:
   ' Fast Fourier Transform Subroutine
   PI=3.1415926535
   '    BEGIN COMPLEX INPUT FFT
   K2=1
   FOR K=1 TO M
     K2=2*K2
     K1=K2/2
     TH=(2*PI/N)*K1
     NK=N/K2
     N1=N/K1
     FOR I=1 TO NK
       AG=(I-1)*TH
       WR=COS(AG)
       WI=-SIN(AG)
   	 FOR J=N1 TO N STEP N1
   	   J1=J-N1+(I-1)
   	   J2=J1+NK
   	   E1=2*J1
   	   E2=2*J2
   	   O1=E1+1
   	   O2=E2+1
   	   DR=X(E1)-X(E2)
   	   DI=X(O1)-X(O2)
   	   X(E1)=X(E1)+X(E2)
   	   X(O1)=X(O1)+X(O2)
   	   X(E2)=WR*DR-WI*DI
   	   X(O2)=WI*DR+WR*DI
   	 NEXT
       NEXT
     NEXT
   '        END OF COMPLEX INPUT FFT

 '       PERFORM BIT REVERSAL
   J=0:
   FOR I=0 TO N-2
     IF I<J THEN
       EI=2*I
       EJ=2*J
       T=X(EI)
       X(EI)=X(EJ)
       X(EJ)=T
       T=X(EI+1)
       X(EI+1)=X(EJ+1)
       X(EJ+1)=T
     END IF
     K=N/2
AGAIN:
    IF K>J THEN
      J=J+K
    ELSE
      J=J-K
      K=K/2
      GOTO AGAIN
    END IF
   NEXT
   '      UNPACK ARRAY TO GET POSITIVE FREQUENCY SPECTRUM
   T=X(0)+X(1)
   X(1)=X(0)-X(1)
   X(0)=T
   X(N+1)=-X(N+1)
   N2=2*N
   FOR K=1 TO N/2-1
     K2=2*K
     NK=N2-K2
     AR=X(K2)+X(NK)
     AI=X(K2+1)-X(NK+1)
     BR=X(NK)-X(K2)
     BI=-X(NK+1)-X(K2+1)
     S=SIN(K*PI/N)
     C=COS(K*PI/N)
     CR=BR*S-BI*C
     CI=BR*C+BI*S
     X(K2)=(AR+CR)/2
     X(K2+1)=(AI+CI)/2
     X(NK)=(AR-CR)/2
     X(NK+1)=(CI-AI)/2
   NEXT
 RETURN
 ' END FFT SUBROUTINE

