{___________________________________________________________________________
ffir.h  This is the header file for the fft based FIR program FFIR.ASM
____________________________________________________________________________}
#include    "def21020.h"

#define	    TAPS	32		    /* Number of FIR taps	   */
#define     PNTS        256		    /* Points in the FFT	   */
#define	    LOGPNTS	8		    /* log2(PNTS)		   */
#define	    SEG		(PNTS-TAPS+1)	    /* Number of samples proc./FFT */


{________The constants below must be changed for different length FFTs_______
 N      = number of points in the FFT 
 STAGES = log4(N) 
 OST    = bitrev(0x00000080=N/2), used as a modifier for bit reversal
 ORE    = bitrev(0x00000000=output real in dm)
 OIM    = bitrev(0x00004000=output imag in dm) 
____________________________________________________________________________}
#define	N	PNTS
#define	STAGES	(LOGPNTS/2)
#define OST	0x01000000
#define ORE	0x00000000
#define OIM	0x00080000

{ This are the bit definitions of USTAT1}
#define     OUTBF       0x00020000          /* Out audio buffer full */
#define     OUTBH       0x00010000          /* Out audio buffer half-full */

