load inreal32.mat;
load inimag32.mat;
j=sqrt(-1);
incplx=inreal32+(inimag32*j);
load rdata.mat;
load idata.mat;
y=(1:32);

plot(y,abs(fft(incplx)),'r',y,(sqrt((rdata.*rdata)+(idata.*idata))),'g')
grid
title('Magnitude Comparison, 21k in green')
pause
plot(y,abs(fft(incplx))-(sqrt((rdata.*rdata)+(idata.*idata))))
grid
title('Error in Magnitude')
pause

plot(y,real(fft(incplx)),'r',y,rdata,'g')
grid
title('Real Part Comparison, 21k in green')
pause
plot(y,real(fft(incplx))-rdata)
grid
title('Error in Real')
pause

plot(y,imag(fft(incplx)),'r',y,idata,'g')
grid
title('Imaginary Part Comparison, 21k in green')
pause
plot(y,imag(fft(incplx))-idata)
grid
title('Error in Imaginary')
pause
