/**************************************************************
  
                 test.c
  
                 Leor Brenman
  
                 03-16-92
  
           (C) Texas Instruments Inc., 1992 
  
           Refer to the file 'license.txt' included with this 
           this package for usage and license information. 
  
*************************************************************/
/************************************************************************/
/*   TEST.C:  C31-CS4215 I/F Test Code                                  */
/*   Leor Brenman, DSP Applications                                     */
/*   (C) 1991 TEXAS INSTRUMENTS, HOUSTON                                */
/************************************************************************/
#include <string.h>
#include <cs4215.h>
#define   XTAL1     1
#define   EIGHT_KHZ 0

extern VPVF input0,input1,output0,output1;

void main(void)
{
    VI j;
    VF volume = 0.5, balance = 0.5;

    init_c30();

    INIT_ARRAYS;

    init_4215(XTAL1,CONV_FREQ_3);

    for(;;)
    {
         WAIT_BUFFERS;

         /* PROCESS INPUT DATA (input) INTO OUTPUT DATA (output) */
         for(j=0;j<BLOCK_SIZE;j++)
         {
           output0[j] = balance*volume*input0[j];
           output1[j] = (1 - balance)*volume*input1[j];
         }

         RESET_FLAGS;
    }
}
