/**  Program Listing 1. EPROM Boot Program - DSP in Memory Mode 2.  **/

/*  This code resides in EPROM beginning at address 0.	*/

#define code_length	511	/* number of 32-bit instructions-1	*/
#define code_from	instr	/* starting location of code in EPROM	*/
#define code_to		0xf000	/* starting On-chip RAM location	*/

	r1 = code_length
	r2 = code_from
	r3 = code_to
loop: a0 =(*r3++ = *r2++) +a0	/* transfer code from EPROM to on-chip RAM */
	if (r1-- >= 0) goto loop
	nop
	goto code_to		/* start executing code from on chip RAM */
	nop

instr:	/* user-executable code goes here */

