/* AT&T DSP16,  128 point FFT         jkf  Jul 26, 1989 */
/*							*/
/* 128-point DIT FFT subroutine				*/

main:	auc=0x2
	pt=inputs
	r0=0x0
	do 16	{
		y=*r0	x=*pt++
	*r0++=x
	}
	c0=-14
mloop:	pt=inputs
	redo 16
	if c0lt goto mloop

	call _fft128

pause:	goto pause

inputs:	int	0.707
	int	0.0
	int	1.99993
	int	0.0
	int	0.707
	int	0.0
	int	-1.0
	int	0.0
	int	-0.707
	int	0.0
	int	0.0
	int	0.0
	int	-0.707
	int	0.0
	int	-1.0
	int	0.0

/*	routine			*/

_fft128:			/* 128-point DIT FFT subroutine		*/
	auc=0x2
	i=-1
level0:	r0=0x0
	r1=128
	r2=127
	pt=W0
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	do 64 {
	p=x*y x=*pt++i y=*r1--	/* p=Ur*A(k+n/2)r, x=Ui, y=A(k+n/2)i	*/
	a1=a0-p *r2++=a1	/* a1=A(k)r-Ur*A(k+n/2)r	*/
	a0=a0+p	p=x*y		/* a0=A(k)r+Ur*A(k+n/2)r,p=Ui*A(k+n/2)i	*/
	a0=a0-p y=*r1++		/* a0=A(k)r+Ur*A(k+n/2)r-Ui*A(k+n/2)i	*/
	a0=a0>>1		/* a0=a0/2, y=A(k+n/2)r		*/
	a1=a1+p p=x*y *r0m2:a0	/* a1=A(k)r-Ur*A(k+n/2)r+Ui*A(k+n/2)i	*/
	x=*pt++ y=*r1++		/* p=Ui*A(k+n/2)r,x=Ur,y=A(k+n/2)i	*/
	a1=a1>>1		/* a1=a1/2, x=Ur, y=A(k+n/2)i	*/
	a1=a0-p *r2++=a1	/* a1=A(k)i-Ui*A(k+n/2)r	*/
	a0=a0+p p=x*y		/* a0=A(k)i+Ui*A(k+n/2)r,p=Ur*A(k+n/2)i	*/
	a0=a0+p y=*r1++		/* a0=A(k)i+Ui*A(k+n/2)r+Ur*A(k+n/2)i	*/
	a0=a0>>1		/* a0=a0/2, y=A(k+1+n/2)r	*/
	a1=a1-p *r0m2:a0 	/* a1=A(k)i-Ui*A(k+n/2)r-Ur*A(k+n/2)i	*/
	a1=a1>>1		/* a1=a1/2, x=Ur		*/
	}
	*r2=a1

level1:	r0=0x0
	r1=64
	r2=63
	pt=W0
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 32
	*r2=a1
	r0=128
	r1=192
	r2=191
	pt=W32
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 32
	*r2=a1

level2:	r0=0x0
	r1=32
	r2=31
	pt=W0
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=64
	r1=96
	r2=95
	pt=W32
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=128
	r1=160
	r2=159
	pt=W16
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1
	r0=192
	r1=224
	r2=223
	pt=W48
	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 16
	*r2=a1

level3:	r0=0
	r1=16
	r2=15
	pt=W0
	c0=-7
loop3:	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 8
	*r2++=a1
	a0=r2
	r0=a0
	y=16
	a0=a0+y
	r1=a0
	r2=a0
	y=*r2-- x=*pt++
	if c0lt goto loop3

level4:	r0=0
	r1=8
	r2=7
	pt=W0
	c0=-15
loop2:	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 4
	*r2++=a1
	a0=r2
	r0=a0
	y=8
	a0=a0+y
	r1=a0
	r2=a0
	y=*r2-- x=*pt++
	if c0lt goto loop2

level5:	r0=0
	r1=4
	r2=3
	pt=W0
	c0=-31
loop1:	a0=*r0++		/* a0=A(0)r		*/
	a1=*r2			/* a1=A(n/2-1)i		*/
	x=*pt++ y=*r1++		/* x=Ur; y=A(n/2)r	*/
	redo 2
	*r2++=a1
	a0=r2
	r0=a0
	y=4
	a0=a0+y
	r1=a0
	r2=a0
	y=*r2-- x=*pt++
	if c0lt goto loop1

	r0=0x0
	a0=*r0++
	do 100 {
	a0=a0>>1
	*r0m2:a0
	}
	redo 100
	redo 56

level6:	r0=0x0
	r1=0x2
	r2=0x2
	pt=W0
	a0=*r0			/* a0=A(k)r		*/
	x=*pt++ y=*r1++		/* x=Ur, y=A(k+1)r		*/
	p=x*y y=*r1-- x=*pt++i	/* p=Ur*A(k+1)r,x=Ui,y=A(k+1)i	*/
	j=3
	do 64 {
	a1=a0-p		/* a1=A(k)r-Ur*A(k+1)r		*/
	a0=a0+p p=x*y	/* a0=A(k)r+Ur*A(k+1)r,p=Ui*A(k+1)i	*/
	a0=a0-p y=*r1++	/* a0=A(k)r+Ur*A(k+1)r-Ui*A(k+1)i,y=A(k+1)r	*/
	a1=a1+p p=x*y *r0++=a0	/* p=Ui*A(k+1)r		*/
	x=*pt++ y=*r1++j		/* x=Ur, y=A(k+1)i	*/
	a0=*r0			/* a0=A(k)i		*/
	a1=a0-p *r2++=a1	/* a1=a(k)i-Ui*A(k+1)r	*/
	a0=a0+p p=x*y y=*r1 x=*pt++	/* p=Ur*A(k+1)i,x=Ui,y=A(k+2)r	*/
	a0=a0+p y=*r1++ x=*pt++	/* x=Ur', y=A(k+3)r	*/
	a1=a1-p p=x*y *r0++j=a0	/* p=Ur'*A(k+3)r	*/
	y=*r1-- x=*pt++i	/* x=Ui', y=A(k+3)i	*/
	a0=*r0			/* a0=A(k+2)r		*/
	*r2++j=a1
	}

/* Bit reverse		*/

	pt=bitrev
	y=a0 x=*pt++
	a0=x
	y=a0 x=*pt++
	do 64 {
	r0=a0
	a1=x
	r1=a1
	y=*r0++ x=*pt++
	a0=x
	a1=*r0--
	*r1zp:y x=*pt++
	*r1zp:a1
	*r0++=y
	*r0=a1
	}

	return

/* twiddle table			*/

W0:	int	1.0
	int	0.0
W32:	int	0.0
	int	-1.0
W16:	int	0.7071068
	int	-0.7071068
W48:	int	-0.7071068
	int	-0.7071068
W8:	int	0.9238795	/* cos (-pi/64 * 8)	*/
	int	-0.3826834	/* sin (-pi/64 * 8)	*/
W40:	int	-0.3826834	/* cos (-pi/64  * 40)	*/
	int	-0.9238795	/* sin (-pi/64  * 40)	*/
W24:	int	0.3826834
	int	-0.9238795
W56:	int	-0.9238795
	int	-0.3826834
W4:	int	0.9807853
	int	-0.1950903
W36:	int	-0.1950903
	int	-0.9807853
W20:	int	0.5555702
	int	-0.8314696
W52:	int	-0.8314696
	int	-0.5555702
W12:	int	0.8314696
	int	-0.5555702
W44:	int	-0.5555702
	int	-0.8314696
W28:	int	0.1950903	/* cos (-pi/64  * 28)	*/
	int	-0.9807853	/* sin (-pi/64  * 28)	*/
W60:	int	-0.9807853
	int	-0.1950903
W2:	int	0.9951847
	int	-0.0980171
W34:	int	-0.0980171
	int	-0.9951847
W18:	int	0.6343933
	int	-0.7730105
W50:	int	-0.7730105
	int	-0.6343933
W10:	int	0.8819213
	int	-0.4713967
W42:	int	-0.4713967
	int	-0.8819213
W26:	int	0.2902847	/* cos (-pi/64  * 26)	*/
	int	-0.9569403	/* sin (-pi/64  * 26)	*/
W58:	int	-0.9569403
	int	-0.2902846
W6:	int	0.9569403
	int	-0.2902847
W38:	int	-0.2902847
	int	-0.9569403
W22:	int	0.4713967
	int	-0.8819213
W54:	int	-0.8819213
	int	-0.4713967
W14:	int	0.7730105
	int	-0.6343933
W46:	int	-0.6343933
	int	-0.7730105
W30:	int	0.0980171	/* cos (-pi/64  * 30)	*/
	int	-0.9951847	/* sin (-pi/64  * 30)	*/
W62:	int	-0.9951847
	int	-0.0980171
W1:	int	0.9987955
	int	-0.0490677
W33:	int	-0.0490677
	int	-0.9987955
W17:	int	0.6715590
	int	-0.7409511
W49:	int	-0.7409511
	int	-0.6715590
W9:	int	0.9039893
	int	-0.4275551
W41:	int	-0.4275551
	int	-0.9030893
W25:	int	0.3368899
	int	-0.9415441
W57:	int	-0.9415441
	int	-0.3368899
W5:	int	0.9700313
	int	-0.2429802
W37:	int	-0.2429802
	int	-0.9700313
W21:	int	0.5141027
	int	-0.8577286
W53:	int	-0.8577286
	int	-0.5141027
W13:	int	0.8032075	/* cos (-pi/64  * 13)	*/
	int	-0.5956993	/* sin (-pi/64  * 13)	*/
W45:	int	-0.5956993
	int	-0.8032075
W29:	int	0.1467305
	int	-0.9891765
W61:	int	-0.9891765
	int	-0.1467305
W3:	int	0.9891765
	int	-0.1467305
W35:	int	-0.1467305
	int	-0.9891765
W19:	int	0.5956993
	int	-0.8032075
W51:	int	-0.8032075
	int	-0.5956993
W11:	int	0.8577286
	int	-0.5141027
W43:	int	-0.5141027
	int	-0.8577286
W27:	int	0.2429802
	int	-0.9700313
W59:	int	-0.9700313
	int	-0.2429802
W7:	int	0.9415441	/* cos (-pi/64  * 7)	*/
	int	-0.3368899	/* sin (-pi/64  * 7)	*/
W39:	int	-0.3368899
	int	-0.9415441
W23:	int	0.4275551
	int	-0.9039893
W55:	int	-0.9039893
	int	-0.4275551
W15:	int	0.7409511
	int	-0.6715590
W47:	int	-0.6715590
	int	-0.7409511
W31:	int	0.0490677
	int	-0.9987955
W63:	int	-0.9987955
	int	-0.0490677

/* Bit reversal table for 128 points fft	*/

bitrev:	int	0x2
	int	0x80
	int	0x4
	int	0x40
	int	0x6
	int	0xc0
	int	0x8
	int	0x20
	int	0xa
	int	0xa0
	int	0xc
	int	0x60
	int	0xe
	int	0xe0
	int	0x10
	int	0x10
	int	0x12
	int	0x90
	int	0x14
	int	0x50
	int	0x16
	int	0xd0
	int	0x18
	int	0x30
	int	0x1a
	int	0xb0
	int	0x1c
	int	0x70
	int	0x1e
	int	0xf0
	int	0x22
	int	0x88
	int	0x24
	int	0x48
	int	0x26
	int	0xc8
	int	0x2a
	int	0xa8
	int	0x2c
	int	0x68
	int	0x2e
	int	0xe8
	int	0x32
	int	0x98
	int	0x34
	int	0x58
	int	0x36
	int	0xd8
	int	0x38
	int	0x38
	int	0x3a
	int	0xb8
	int	0x3c
	int	0x78
	int	0x3e
	int	0xf8
	int	0x42
	int	0x84
	int	0x46
	int	0xc4
	int	0x4a
	int	0xa4
	int	0x4c
	int	0x64
	int	0x4e
	int	0xe4
	int	0x52
	int	0x94
	int	0x54
	int	0x54
	int	0x56
	int	0xd4
	int	0x5a
	int	0xb4
	int	0x5c
	int	0x74
	int	0x5e
	int	0xf4
	int	0x62
	int	0x8c
	int	0x66
	int	0xcc
	int	0x6a
	int	0xac
	int	0x6e
	int	0xec
	int	0x72
	int	0x9c
	int	0x76
	int	0xdc
	int	0x7a
	int	0xbc
	int	0x7c
	int	0x7c
	int	0x7e
	int	0xfc
	int	0x86
	int	0xc2
	int	0x8a
	int	0xa2
	int	0x8e
	int	0xe2
	int	0x92
	int	0x92
	int	0x96
	int	0xd2
	int	0x9a
	int	0xb2
	int	0x9e
	int	0xf2
	int	0xa6
	int	0xca
	int	0xae
	int	0xea
	int	0xb6
	int	0xda
	int	0xba
	int	0xba
	int	0xbe
	int	0xfa
	int	0xce
	int	0xe6
	int	0xd6
	int	0xd6
	int	0xde
	int	0xf6
	int	0xfa
	int	0xbe


